---------------------
PatchSet 1154 
Date: 2001/01/07 09:48:26
Author: hno
Branch: auth_rewrite
Tag: (none) 
Log:
indent

Members: 
	ChangeLog:1.1.1.3.10.7.2.2->1.1.1.3.10.7.2.3 
	auth_modules/LDAP/squid_ldap_auth.c:1.1.1.1->1.1.1.1.26.1 
	auth_modules/MSNT/allowusers.c:1.1.4.1->1.1.4.1.2.1 
	auth_modules/MSNT/byteorder.h:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/confload.c:1.1.4.1->1.1.4.1.2.1 
	auth_modules/MSNT/denyusers.c:1.1.6.2->1.1.6.2.2.1 
	auth_modules/MSNT/md4.c:1.1.1.1->1.1.1.1.26.1 
	auth_modules/MSNT/msntauth.c:1.1.4.1->1.1.4.1.2.1 
	auth_modules/MSNT/rfcnb-common.h:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/rfcnb-error.h:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/rfcnb-io.c:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/rfcnb-io.h:1.1.1.1->1.1.1.1.26.1 
	auth_modules/MSNT/rfcnb-priv.h:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/rfcnb-util.c:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/rfcnb-util.h:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/rfcnb.h:1.1.1.1->1.1.1.1.26.1 
	auth_modules/MSNT/session.c:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/smbdes.c:1.1.1.1->1.1.1.1.26.1 
	auth_modules/MSNT/smbencrypt.c:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/smblib-common.h:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/smblib-priv.h:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/smblib-util.c:1.1.1.1.10.1.2.1->1.1.1.1.10.1.2.2 
	auth_modules/MSNT/smblib.c:1.1.1.1.10.2.2.1->1.1.1.1.10.2.2.2 
	auth_modules/MSNT/smblib.h:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/std-defines.h:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/std-includes.h:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/valid.c:1.1.1.1.10.1->1.1.1.1.10.1.2.1 
	auth_modules/MSNT/valid.h:1.1.1.1->1.1.1.1.26.1 
	auth_modules/NCSA/ncsa_auth.c:1.1.1.1->1.1.1.1.30.1 
	auth_modules/SMB/smb_auth.c:1.1.1.2.10.1->1.1.1.2.10.1.2.1 
	auth_modules/getpwnam/getpwnam_auth.c:1.1.1.1->1.1.1.1.30.1 
	include/Array.h:1.1.1.1->1.1.1.1.26.1 
	include/Stack.h:1.1.1.1->1.1.1.1.26.1 
	include/asn1.h:1.1.1.1->1.1.1.1.26.1 
	include/ntlmauth.h:1.1.4.2->1.1.4.3 
	include/radix.h:1.1.1.1->1.1.1.1.26.1 
	include/snmp_client.h:1.1.1.1->1.1.1.1.26.1 
	include/snmp_pdu.h:1.1.1.1->1.1.1.1.26.1 
	include/snmp_vars.h:1.1.1.2->1.1.1.2.22.1 
	lib/GNUregex.c:1.1.1.1->1.1.1.1.26.1 
	lib/base64.c:1.1.1.1.14.1->1.1.1.1.14.1.2.1 
	lib/dlmalloc.c:1.1.1.1->1.1.1.1.26.1 
	lib/ntlmauth.c:1.1.4.4->1.1.4.5 
	lib/util.c:1.1.1.3.10.5.2.1->1.1.1.3.10.5.2.2 
	lib/uudecode.c:1.1.1.1->1.1.1.1.26.1 
	ntlm_auth_modules/NTLMSSP/libntlmssp.c:1.1.2.12.2.7->1.1.2.12.2.8 
	ntlm_auth_modules/NTLMSSP/ntlm.h:1.1.2.12.2.7->1.1.2.12.2.8 
	ntlm_auth_modules/NTLMSSP/ntlm_auth.c:1.1.2.10.2.7->1.1.2.10.2.8 
	ntlm_auth_modules/NTLMSSP/smbval/byteorder.h:1.1.2.1.2.2->1.1.2.1.2.3 
	ntlm_auth_modules/NTLMSSP/smbval/md4.c:1.1.2.1.2.2->1.1.2.1.2.3 
	ntlm_auth_modules/NTLMSSP/smbval/rfcnb-common.h:1.1.2.1.2.2->1.1.2.1.2.3 
	ntlm_auth_modules/NTLMSSP/smbval/rfcnb-error.h:1.1.2.1.2.3->1.1.2.1.2.4 
	ntlm_auth_modules/NTLMSSP/smbval/rfcnb-io.c:1.1.2.1.2.3->1.1.2.1.2.4 
	ntlm_auth_modules/NTLMSSP/smbval/rfcnb-io.h:1.1.2.1.2.3->1.1.2.1.2.4 
	ntlm_auth_modules/NTLMSSP/smbval/rfcnb-priv.h:1.1.2.2.2.3->1.1.2.2.2.4 
	ntlm_auth_modules/NTLMSSP/smbval/rfcnb-util.c:1.1.2.1.2.4->1.1.2.1.2.5 
	ntlm_auth_modules/NTLMSSP/smbval/rfcnb-util.h:1.1.2.1.2.3->1.1.2.1.2.4 
	ntlm_auth_modules/NTLMSSP/smbval/rfcnb.h:1.1.2.1.2.3->1.1.2.1.2.4 
	ntlm_auth_modules/NTLMSSP/smbval/session.c:1.1.2.1.2.4->1.1.2.1.2.5 
	ntlm_auth_modules/NTLMSSP/smbval/smbdes.c:1.1.2.1.2.2->1.1.2.1.2.3 
	ntlm_auth_modules/NTLMSSP/smbval/smbdes.h:1.1.2.3->1.1.2.4 
	ntlm_auth_modules/NTLMSSP/smbval/smbencrypt.c:1.1.2.1.2.4->1.1.2.1.2.5 
	ntlm_auth_modules/NTLMSSP/smbval/smbencrypt.h:1.1.2.3->1.1.2.4 
	ntlm_auth_modules/NTLMSSP/smbval/smblib-common.h:1.1.2.2.2.2->1.1.2.2.2.3 
	ntlm_auth_modules/NTLMSSP/smbval/smblib-priv.h:1.1.2.2.2.4->1.1.2.2.2.5 
	ntlm_auth_modules/NTLMSSP/smbval/smblib-util.c:1.1.2.1.2.5->1.1.2.1.2.6 
	ntlm_auth_modules/NTLMSSP/smbval/smblib.c:1.1.2.6.2.5->1.1.2.6.2.6 
	ntlm_auth_modules/NTLMSSP/smbval/smblib.h:1.1.2.1.2.3->1.1.2.1.2.4 
	ntlm_auth_modules/NTLMSSP/smbval/std-defines.h:1.1.2.3.2.2->1.1.2.3.2.3 
	ntlm_auth_modules/NTLMSSP/smbval/std-includes.h:1.1.2.1.2.2->1.1.2.1.2.3 
	ntlm_auth_modules/NTLMSSP/smbval/valid.c:1.1.2.1.2.3->1.1.2.1.2.4 
	ntlm_auth_modules/NTLMSSP/smbval/valid.h:1.1.2.1.2.2->1.1.2.1.2.3 
	ntlm_auth_modules/fakeauth/fakeauth_auth.c:1.1.2.6.2.7->1.1.2.6.2.8 
	ntlm_auth_modules/fakeauth/ntlm.h:1.1.2.3.2.2->1.1.2.3.2.3 
	snmplib/coexistance.c:1.1.1.1->1.1.1.1.30.1 
	snmplib/mib.c:1.1.1.1->1.1.1.1.30.1 
	snmplib/snmp_api.c:1.1.1.1->1.1.1.1.30.1 
	snmplib/snmp_api_error.c:1.1.1.1->1.1.1.1.30.1 
	snmplib/snmp_msg.c:1.1.1.1->1.1.1.1.30.1 
	snmplib/snmp_pdu.c:1.1.1.1->1.1.1.1.30.1 
	src/HttpRequest.c:1.1.1.3.10.2.2.3->1.1.1.3.10.2.2.4 
	src/access_log.c:1.1.1.3.12.7.2.4->1.1.1.3.12.7.2.5 
	src/acl.c:1.1.1.3.12.26.2.22->1.1.1.3.12.26.2.23 
	src/authenticate.c:1.1.1.3.12.17.2.23->1.1.1.3.12.17.2.24 
	src/cache_cf.c:1.1.1.3.4.1.2.9.2.15->1.1.1.3.4.1.2.9.2.16 
	src/client_side.c:1.1.1.3.4.1.2.30.2.16->1.1.1.3.4.1.2.30.2.17 
	src/defines.h:1.1.1.3.12.9.2.4->1.1.1.3.12.9.2.5 
	src/enums.h:1.1.1.3.12.15.2.6->1.1.1.3.12.15.2.7 
	src/errorpage.c:1.1.1.3.10.9.2.8->1.1.1.3.10.9.2.9 
	src/ftp.c:1.1.1.3.4.1.2.8.2.3->1.1.1.3.4.1.2.8.2.4 
	src/globals.h:1.1.1.3.12.8.2.3->1.1.1.3.12.8.2.4 
	src/helper.c:1.1.1.3.12.13.2.6->1.1.1.3.12.13.2.7 
	src/http.c:1.1.1.3.4.1.2.10.2.5->1.1.1.3.4.1.2.10.2.6 
	src/main.c:1.1.1.3.4.1.2.12.2.5->1.1.1.3.4.1.2.12.2.6 
	src/mem.c:1.1.1.3.12.9.2.2->1.1.1.3.12.9.2.3 
	src/protos.h:1.1.1.3.12.17.2.20->1.1.1.3.12.17.2.21 
	src/redirect.c:1.1.1.3.4.1.2.2.2.3->1.1.1.3.4.1.2.2.2.4 
	src/structs.h:1.1.1.3.4.1.2.26.2.25->1.1.1.3.4.1.2.26.2.26 
	src/tools.c:1.1.1.3.10.7.2.5->1.1.1.3.10.7.2.6 
	src/typedefs.h:1.1.1.3.12.13.2.17->1.1.1.3.12.13.2.18 
	src/auth/basic/auth_basic.c:1.1.2.20->1.1.2.21 
	src/auth/basic/auth_basic.h:1.1.2.6->1.1.2.7 
	src/auth/ntlm/auth_ntlm.c:1.1.2.17->1.1.2.18 
	src/auth/ntlm/auth_ntlm.h:1.1.2.6->1.1.2.7 
	src/fs/ufs/store_dir_ufs.c:1.1.10.8.2.4->1.1.10.8.2.5 
	src/repl/lru/store_repl_lru.c:1.1.10.2.2.1->1.1.10.2.2.2 
	test-suite/hash.c:1.1.1.1->1.1.1.1.26.1 
	test-suite/hash.h:1.1.1.1->1.1.1.1.30.1 
	test-suite/membanger.c:1.1.1.1->1.1.1.1.30.1 
	test-suite/pconn-banger.c:1.1.1.1->1.1.1.1.30.1 
	test-suite/tcp-banger3.c:1.1.1.2->1.1.1.2.30.1 
	test-suite/waiter.c:1.1.1.1->1.1.1.1.30.1 

Index: squid/ChangeLog
===================================================================
RCS file: /cvsroot/squid-sf//squid/ChangeLog,v
retrieving revision 1.1.1.3.10.7.2.2
retrieving revision 1.1.1.3.10.7.2.3
diff -u -r1.1.1.3.10.7.2.2 -r1.1.1.3.10.7.2.3
--- squid/ChangeLog	30 Dec 2000 22:48:18 -0000	1.1.1.3.10.7.2.2
+++ squid/ChangeLog	7 Jan 2001 09:48:26 -0000	1.1.1.3.10.7.2.3
@@ -1,5 +1,12 @@
 
 Changes to squid-2.5
+	- Major rewrite of proxy authentication to support other schemes
+	  than basic. First in the line is NTLM support but others can
+	  easily be added (digest is on the way). See Programmers Guide.
+	  (Robert Collins & Chemolli Francesco)
+	- Reworked how request bodies are passed down to the protocols.
+	  Now all client side processing is inside client_side.c, and
+	  the pass and pump modules is no longer used.
 	- Fixed forwarding/peer loop detection code (Brian Degenhardt) -
 	  now a peer is ignored if it turns out to be us, rather than
 	  committing suicide
@@ -71,9 +78,6 @@
 	  a more modular fashion. The object replacement and IO is now
 	  responsibility of the storage directory, and not of the storage
 	  manager.
-	- Reworked how request bodies are passed down to the protocols.
-	  Now all client side processing is inside client_side.c, and
-	  the pass and pump modules is no longer used.
 	- Fixed a bogous MD5 mismatch warning sometimes seen when using
 	  aufs or diskd stores
 	- Added --enable-stacktraces configure option to set PRINT_STACK_TRACE,
Index: squid/auth_modules/LDAP/squid_ldap_auth.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/auth_modules/LDAP/Attic/squid_ldap_auth.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.26.1
diff -u -r1.1.1.1 -r1.1.1.1.26.1
--- squid/auth_modules/LDAP/squid_ldap_auth.c	26 Jan 2000 03:25:00 -0000	1.1.1.1
+++ squid/auth_modules/LDAP/squid_ldap_auth.c	7 Jan 2001 09:48:27 -0000	1.1.1.1.26.1
@@ -1,22 +1,22 @@
 /*
-
-  squid_ldap_auth: authentication via ldap for squid proxy server
-     
-  Author: Glen Newton 
-	  glen.newton@nrc.ca
-          Advanced Services 
-          CISTI
-	  National Research Council
-
-  Usage: squid_ldap_auth <ldap_server_name>
-
-  Dependencies: You need to get the OpenLDAP libraries
-          from http://www.openldap.org
-
-  License: squid_ldap_auth is free software; you can redistribute it 
-           and/or modify it under the terms of the GNU General Public License 
-	   as published by the Free Software Foundation; either version 2, 
-	   or (at your option) any later version.
+ * 
+ * squid_ldap_auth: authentication via ldap for squid proxy server
+ * 
+ * Author: Glen Newton 
+ * glen.newton@nrc.ca
+ * Advanced Services 
+ * CISTI
+ * National Research Council
+ * 
+ * Usage: squid_ldap_auth <ldap_server_name>
+ * 
+ * Dependencies: You need to get the OpenLDAP libraries
+ * from http://www.openldap.org
+ * 
+ * License: squid_ldap_auth is free software; you can redistribute it 
+ * and/or modify it under the terms of the GNU General Public License 
+ * as published by the Free Software Foundation; either version 2, 
+ * or (at your option) any later version.
  */
 
 #include <stdio.h>
@@ -28,79 +28,70 @@
 /* Change this to your search base */
 #define SEARCHBASE "ou=people,o=nrc.ca"
 
-int checkLDAP( LDAP *ld, char *userid, char *password);
+int checkLDAP(LDAP * ld, char *userid, char *password);
 
-int main(int argc, char **argv)
+int
+main(int argc, char **argv)
 {
-  char buf[256]; 
-  char *user, *passwd, *p;
-  char *ldapServer;
-  LDAP *ld;
-  LDAPMessage *result, *e;
-
-  setbuf(stdout, NULL);
-
-  if (argc != 2) 
-    {
-      fprintf(stderr, "Usage: squid_ldap_auth ldap_server_name\n");
-      exit(1);
+    char buf[256];
+    char *user, *passwd, *p;
+    char *ldapServer;
+    LDAP *ld;
+    LDAPMessage *result, *e;
+
+    setbuf(stdout, NULL);
+
+    if (argc != 2) {
+	fprintf(stderr, "Usage: squid_ldap_auth ldap_server_name\n");
+	exit(1);
     }
+    ldapServer = (char *) argv[1];
 
-  ldapServer = (char*)argv[1];
-  
-  while (fgets(buf, 256, stdin) != NULL) 
-    {
-      /* You can put this ldap connect outside the loop, but i didn't want to 
-	 have the connection open too much. If you have a site which will 
-	 be doing >1 authentication per second, you should move this (and the 
-	 below ldap_unbind()) outside the loop. 
-      */
-      if( (ld = ldap_init(ldapServer, LDAP_PORT)) == NULL)
-	{
-	  fprintf(stderr, "\nUnable to connect to LDAP server:%s port:%d\n",
-		  ldapServer, LDAP_PORT);
-	  exit(1);
+    while (fgets(buf, 256, stdin) != NULL) {
+	/* You can put this ldap connect outside the loop, but i didn't want to 
+	 * have the connection open too much. If you have a site which will 
+	 * be doing >1 authentication per second, you should move this (and the 
+	 * below ldap_unbind()) outside the loop. 
+	 */
+	if ((ld = ldap_init(ldapServer, LDAP_PORT)) == NULL) {
+	    fprintf(stderr, "\nUnable to connect to LDAP server:%s port:%d\n",
+		ldapServer, LDAP_PORT);
+	    exit(1);
 	}
+	if ((p = strchr(buf, '\n')) != NULL)
+	    *p = '\0';		/* strip \n */
 
-      if ((p = strchr(buf, '\n')) != NULL)
-	*p = '\0';		/* strip \n */
-
-      if ((user = strtok(buf, " ")) == NULL) 
-	{
-	  printf("ERR\n");
-	  continue;
+	if ((user = strtok(buf, " ")) == NULL) {
+	    printf("ERR\n");
+	    continue;
 	}
-      if ((passwd = strtok(NULL, "")) == NULL) 
-	{
-	  printf("ERR\n");
-	  continue;
+	if ((passwd = strtok(NULL, "")) == NULL) {
+	    printf("ERR\n");
+	    continue;
 	}
-      if(checkLDAP(ld, user, passwd) != 0)
-	{
-	  printf("ERR\n");
-	  continue;
+	if (checkLDAP(ld, user, passwd) != 0) {
+	    printf("ERR\n");
+	    continue;
+	} else {
+	    printf("OK\n");
 	}
-      else
-	{
-	  printf("OK\n");
-	}      
-      ldap_unbind(ld);
+	ldap_unbind(ld);
     }
 }
 
 
 
-int checkLDAP(  LDAP *ld, char *userid, char *password)
+int
+checkLDAP(LDAP * ld, char *userid, char *password)
 {
-  char str[256];
+    char str[256];
+
+    /*sprintf(str,"uid=[%s][%s], %s",userid, password, SEARCHBASE); */
+    sprintf(str, "uid=%s, %s", userid, SEARCHBASE);
 
-  /*sprintf(str,"uid=[%s][%s], %s",userid, password, SEARCHBASE); */
-  sprintf(str,"uid=%s, %s",userid, SEARCHBASE);
-  
-  if(ldap_simple_bind_s(ld, str, password) != LDAP_SUCCESS)
-    {
-      /*fprintf(stderr, "\nUnable to bind\n");*/
-      return 33;
+    if (ldap_simple_bind_s(ld, str, password) != LDAP_SUCCESS) {
+	/*fprintf(stderr, "\nUnable to bind\n"); */
+	return 33;
     }
-  return 0;
+    return 0;
 }
Index: squid/auth_modules/MSNT/allowusers.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/auth_modules/MSNT/Attic/allowusers.c,v
retrieving revision 1.1.4.1
retrieving revision 1.1.4.1.2.1
diff -u -r1.1.4.1 -r1.1.4.1.2.1
--- squid/auth_modules/MSNT/allowusers.c	5 Nov 2000 13:42:35 -0000	1.1.4.1
+++ squid/auth_modules/MSNT/allowusers.c	7 Jan 2001 09:48:27 -0000	1.1.4.1.2.1
@@ -1,13 +1,13 @@
 
 /*
-  allowusers.c
-  (C) 2000 Antonino Iannella, Stellar-X Pty Ltd
-  Released under GPL, see COPYING-2.0 for details.
-
-  These routines are to allow users attempting to use the proxy which
-  have been explicitly allowed by the system administrator.
-  The code originated from denyusers.c.
-*/
+ * allowusers.c
+ * (C) 2000 Antonino Iannella, Stellar-X Pty Ltd
+ * Released under GPL, see COPYING-2.0 for details.
+ * 
+ * These routines are to allow users attempting to use the proxy which
+ * have been explicitly allowed by the system administrator.
+ * The code originated from denyusers.c.
+ */
 
 #include <stdio.h>
 #include <stdlib.h>
@@ -20,191 +20,173 @@
 #include <ctype.h>
 #include <sys/param.h>
 
-#define NAMELEN     50                          /* Maximum username length */
+#define NAMELEN     50		/* Maximum username length */
 
 /* Global variables */
 
-char   *AllowedUsers;        /* Pointer to string of allowed users */
-off_t  AllowUserSize;        /* Size of allowed users file */
-struct stat FileBuf;         /* Stat data buffer */
-time_t LastModTime;          /* Last allowed user file modification time */
+char *AllowedUsers;		/* Pointer to string of allowed users */
+off_t AllowUserSize;		/* Size of allowed users file */
+struct stat FileBuf;		/* Stat data buffer */
+time_t LastModTime;		/* Last allowed user file modification time */
 
-char Allowuserpath[MAXPATHLEN];    /* MAXPATHLEN defined in param.h */
+char Allowuserpath[MAXPATHLEN];	/* MAXPATHLEN defined in param.h */
 
 /* Function declarations */
 
-int  Read_allowusers();
-int  Check_ifuserallowed(char *);
+int Read_allowusers();
+int Check_ifuserallowed(char *);
 void Checkforchange();
 void Checktimer();
 
 /*
-  Reads the allowed users file for all users to be permitted.
-  Returns 0 if the user list was successfully loaded,
-  and 1 in case of error.
-  Logs any messages to the syslog daemon.
-*/
- 
-int Read_allowusers()
+ * Reads the allowed users file for all users to be permitted.
+ * Returns 0 if the user list was successfully loaded,
+ * and 1 in case of error.
+ * Logs any messages to the syslog daemon.
+ */
+
+int 
+Read_allowusers()
 {
-  FILE   *AFile;            /* Allowed users file pointer */
-  off_t  APos = 0;          /* File counter */
-  char   AChar;             /* Character buffer */
-
-  /* Stat the file. If it does not exist, save the size as zero.
-     Clear the allowed user string. Return. */
-  if (stat(Allowuserpath, &FileBuf) == -1)
-  {
-     if (errno == ENOENT)
-     {
-        LastModTime = (time_t) 0;
-        AllowUserSize = 0;
-        free(AllowedUsers);
-        AllowedUsers = malloc(sizeof(char));
-        AllowedUsers[0] = '\0';
-        return 0;
-     }
-     else
-     {
-        syslog(LOG_USER | LOG_ERR, strerror(errno));
-        return 1;
-     }
-  }
-
-  /* If it exists, save the modification time and size */
-  LastModTime  = FileBuf.st_mtime;
-  AllowUserSize = FileBuf.st_size;
-
-  /* Handle the special case of a zero length file */
-  if (AllowUserSize == 0)
-  {
-     free(AllowedUsers);
-     AllowedUsers = malloc(sizeof(char));
-     AllowedUsers[0] = '\0';
-     return 0;
-  }
-  
-  /* Free and allocate space for a string to store the allowed usernames */
-  free(AllowedUsers);
-
-  if ((AllowedUsers = malloc(sizeof(char) * (AllowUserSize + 3))) == NULL)
-  {
-     syslog(LOG_USER | LOG_ERR, "Read_allowusers: malloc(AllowedUsers) failed.");
-     return 1;
-  }
-
-  /* Open the allowed users file. Report any errors. */
-
-  if ((AFile = fopen(Allowuserpath, "r")) == NULL)
-  {
-     syslog(LOG_USER | LOG_ERR, "Read_allowusers: Failed to open allowed user file.");
-     syslog(LOG_USER | LOG_ERR, strerror(errno));
-     return 1;
-  }
-
-  /* Read user names into the AllowedUsers string.
-     Make sure each string is delimited by a space. */
-
-  AllowedUsers[APos++] = ' ';
-
-  while (!feof(AFile))
-  {
-    if ((AChar = fgetc(AFile)) == EOF)
-       break;
-    else
-    {
-       if (isspace(AChar))
-          AllowedUsers[APos++] = ' ';
-       else
-          AllowedUsers[APos++] = toupper(AChar);
-    }
-  }
-
-  AllowedUsers[APos++] = ' ';
-  AllowedUsers[APos] = '\0';
-  fclose(AFile);
-  return 0;
+    FILE *AFile;		/* Allowed users file pointer */
+    off_t APos = 0;		/* File counter */
+    char AChar;			/* Character buffer */
+
+    /* Stat the file. If it does not exist, save the size as zero.
+     * Clear the allowed user string. Return. */
+    if (stat(Allowuserpath, &FileBuf) == -1) {
+	if (errno == ENOENT) {
+	    LastModTime = (time_t) 0;
+	    AllowUserSize = 0;
+	    free(AllowedUsers);
+	    AllowedUsers = malloc(sizeof(char));
+	    AllowedUsers[0] = '\0';
+	    return 0;
+	} else {
+	    syslog(LOG_USER | LOG_ERR, strerror(errno));
+	    return 1;
+	}
+    }
+    /* If it exists, save the modification time and size */
+    LastModTime = FileBuf.st_mtime;
+    AllowUserSize = FileBuf.st_size;
+
+    /* Handle the special case of a zero length file */
+    if (AllowUserSize == 0) {
+	free(AllowedUsers);
+	AllowedUsers = malloc(sizeof(char));
+	AllowedUsers[0] = '\0';
+	return 0;
+    }
+    /* Free and allocate space for a string to store the allowed usernames */
+    free(AllowedUsers);
+
+    if ((AllowedUsers = malloc(sizeof(char) * (AllowUserSize + 3))) == NULL) {
+	syslog(LOG_USER | LOG_ERR, "Read_allowusers: malloc(AllowedUsers) failed.");
+	return 1;
+    }
+    /* Open the allowed users file. Report any errors. */
+
+    if ((AFile = fopen(Allowuserpath, "r")) == NULL) {
+	syslog(LOG_USER | LOG_ERR, "Read_allowusers: Failed to open allowed user file.");
+	syslog(LOG_USER | LOG_ERR, strerror(errno));
+	return 1;
+    }
+    /* Read user names into the AllowedUsers string.
+     * Make sure each string is delimited by a space. */
+
+    AllowedUsers[APos++] = ' ';
+
+    while (!feof(AFile)) {
+	if ((AChar = fgetc(AFile)) == EOF)
+	    break;
+	else {
+	    if (isspace(AChar))
+		AllowedUsers[APos++] = ' ';
+	    else
+		AllowedUsers[APos++] = toupper(AChar);
+	}
+    }
+
+    AllowedUsers[APos++] = ' ';
+    AllowedUsers[APos] = '\0';
+    fclose(AFile);
+    return 0;
 }
 
 /*
-  Check to see if the username provided by Squid appears in the allowed
-  user list. Returns 0 if the user was not found, and 1 if they were.
-*/
+ * Check to see if the username provided by Squid appears in the allowed
+ * user list. Returns 0 if the user was not found, and 1 if they were.
+ */
 
-int Check_ifuserallowed(char *ConnectingUser)
+int 
+Check_ifuserallowed(char *ConnectingUser)
 {
-  static char CUBuf[NAMELEN + 1];
-  static int  x;
-  static char AllowMsg[256];
-  
-  /* If user string is empty, allow */
-  if (ConnectingUser[0] == '\0')
-     return 1;
-  
-  /* If allowed user list is empty, allow all users.
-     If no users are supposed to be using the proxy, stop squid instead. */
-  if (AllowUserSize == 0)
-     return 1;
-  
-  /* Check if username string is found in the allowed user list.
-     If so, allow. If not, deny. Reconstruct the username
-     to have whitespace, to avoid finding wrong string subsets. */ 
-
-  sscanf(ConnectingUser, " %s ", CUBuf);
-  sprintf(CUBuf, " %s ", CUBuf);
-  
-  for (x = 0; x <= strlen(CUBuf); x++)
-      CUBuf[x] = toupper(CUBuf[x]);
-      
-  if (strstr(AllowedUsers, CUBuf) != NULL)
-     return 1;
-  else                    /* If NULL, they are not allowed to use the proxy */
-  {
-     sprintf(AllowMsg, "Denied access to user '%s'.", CUBuf);
-     syslog(LOG_USER | LOG_ERR, AllowMsg);
-     return 0;
-  }
+    static char CUBuf[NAMELEN + 1];
+    static int x;
+    static char AllowMsg[256];
+
+    /* If user string is empty, allow */
+    if (ConnectingUser[0] == '\0')
+	return 1;
+
+    /* If allowed user list is empty, allow all users.
+     * If no users are supposed to be using the proxy, stop squid instead. */
+    if (AllowUserSize == 0)
+	return 1;
+
+    /* Check if username string is found in the allowed user list.
+     * If so, allow. If not, deny. Reconstruct the username
+     * to have whitespace, to avoid finding wrong string subsets. */
+
+    sscanf(ConnectingUser, " %s ", CUBuf);
+    sprintf(CUBuf, " %s ", CUBuf);
+
+    for (x = 0; x <= strlen(CUBuf); x++)
+	CUBuf[x] = toupper(CUBuf[x]);
+
+    if (strstr(AllowedUsers, CUBuf) != NULL)
+	return 1;
+    else {			/* If NULL, they are not allowed to use the proxy */
+	sprintf(AllowMsg, "Denied access to user '%s'.", CUBuf);
+	syslog(LOG_USER | LOG_ERR, AllowMsg);
+	return 0;
+    }
 }
 
 /*
-  Checks if there has been a change in the allowed users file.
-  If the modification time has changed, then reload the allowed user list.
-  This function is called by the SIGHUP signal handler.
-*/
+ * Checks if there has been a change in the allowed users file.
+ * If the modification time has changed, then reload the allowed user list.
+ * This function is called by the SIGHUP signal handler.
+ */
 
-void Check_forallowchange()
+void 
+Check_forallowchange()
 {
-  struct stat ChkBuf;                     /* Stat data buffer */
-  
- /* Stat the allowed users file. If it cannot be accessed, return. */
-  
-  if (stat(Allowuserpath, &ChkBuf) == -1)
-  {
-     if (errno == ENOENT)
-     {
-        LastModTime = (time_t) 0;
-        AllowUserSize = 0;
-        free(AllowedUsers);
-        AllowedUsers = malloc(sizeof(char));
-        AllowedUsers[0] = '\0';
-        return;
-     }
-     else                  /* Report error when accessing file */
-     {
-        syslog(LOG_USER | LOG_ERR, strerror(errno));
-        return;
-     }
-  }
-
-  /* If found, compare the modification time with the previously-recorded
-     modification time.
-     If the modification time has changed, reload the allowed user list.
-     Log a message of its actions. */
-     
-  if (ChkBuf.st_mtime != LastModTime)
-  {
-     syslog(LOG_USER | LOG_INFO, "Check_forallowchange: Reloading allowed user list.");
-     Read_allowusers();
-  }
-}
+    struct stat ChkBuf;		/* Stat data buffer */
 
+    /* Stat the allowed users file. If it cannot be accessed, return. */
+
+    if (stat(Allowuserpath, &ChkBuf) == -1) {
+	if (errno == ENOENT) {
+	    LastModTime = (time_t) 0;
+	    AllowUserSize = 0;
+	    free(AllowedUsers);
+	    AllowedUsers = malloc(sizeof(char));
+	    AllowedUsers[0] = '\0';
+	    return;
+	} else {		/* Report error when accessing file */
+	    syslog(LOG_USER | LOG_ERR, strerror(errno));
+	    return;
+	}
+    }
+    /* If found, compare the modification time with the previously-recorded
+     * modification time.
+     * If the modification time has changed, reload the allowed user list.
+     * Log a message of its actions. */
+
+    if (ChkBuf.st_mtime != LastModTime) {
+	syslog(LOG_USER | LOG_INFO, "Check_forallowchange: Reloading allowed user list.");
+	Read_allowusers();
+    }
+}
Index: squid/auth_modules/MSNT/byteorder.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/auth_modules/MSNT/Attic/byteorder.h,v
retrieving revision 1.1.1.1.10.1
retrieving revision 1.1.1.1.10.1.2.1
diff -u -r1.1.1.1.10.1 -r1.1.1.1.10.1.2.1
--- squid/auth_modules/MSNT/byteorder.h	12 Jul 2000 22:46:39 -0000	1.1.1.1.10.1
+++ squid/auth_modules/MSNT/byteorder.h	7 Jan 2001 09:48:27 -0000	1.1.1.1.10.1.2.1
@@ -1,36 +1,36 @@
 /* 
-   Unix SMB/Netbios implementation.
-   Version 1.9.
-   SMB Byte handling
-   Copyright (C) Andrew Tridgell 1992-1995
-   
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2 of the License, or
-   (at your option) any later version.
-   
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-   
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-*/
+ * Unix SMB/Netbios implementation.
+ * Version 1.9.
+ * SMB Byte handling
+ * Copyright (C) Andrew Tridgell 1992-1995
+ * 
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
 
 #ifndef _BYTEORDER_H_
 #define _BYTEORDER_H_
 
 /*
-   This file implements macros for machine independent short and 
-   int manipulation
-*/
+ * This file implements macros for machine independent short and 
+ * int manipulation
+ */
 
 #undef CAREFUL_ALIGNMENT
 
 /* we know that the 386 can handle misalignment and has the "right" 
-   byteorder */
+ * byteorder */
 #ifdef __i386__
 #define CAREFUL_ALIGNMENT 0
 #endif
@@ -44,7 +44,7 @@
 #define SCVAL(buf,pos,val) (CVAL(buf,pos) = (val))
 
 typedef unsigned short uint16;
-typedef unsigned int   uint32;
+typedef unsigned int uint32;
 
 #if CAREFUL_ALIGNMENT
 #define SVAL(buf,pos) (PVAL(buf,pos)|PVAL(buf,(pos)+1)<<8)
@@ -59,11 +59,11 @@
 #define SIVALS(buf,pos,val) SIVALX((buf),(pos),((int32)(val)))
 #else
 /* this handles things for architectures like the 386 that can handle
-   alignment errors */
+ * alignment errors */
 /*
-   WARNING: This section is dependent on the length of int16 and int32
-   being correct 
-*/
+ * WARNING: This section is dependent on the length of int16 and int32
+ * being correct 
+ */
 #define SVAL(buf,pos) (*(uint16 *)((char *)(buf) + (pos)))
 #define IVAL(buf,pos) (*(uint32 *)((char *)(buf) + (pos)))
 #define SVALS(buf,pos) (*(int16 *)((char *)(buf) + (pos)))
